Add QA for instance creation with policy violation
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 ACLOCAL_AMFLAGS = -I autotools
24 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
25 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
26 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
27 CHECK_HEADER = $(top_srcdir)/autotools/check-header
28 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
29 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
30 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
31 CHECK_VERSION = $(top_srcdir)/autotools/check-version
32 CHECK_NEWS = $(top_srcdir)/autotools/check-news
33 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
34 DOCPP = $(top_srcdir)/autotools/docpp
35 REPLACE_VARS_SED = autotools/replace_vars.sed
36 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
37 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
38 SHELL_ENV_INIT = autotools/shell-env-init
39
40 # Note: these are automake-specific variables, and must be named after
41 # the directory + 'dir' suffix
42 clientdir = $(pkgpythondir)/client
43 hypervisordir = $(pkgpythondir)/hypervisor
44 httpdir = $(pkgpythondir)/http
45 masterddir = $(pkgpythondir)/masterd
46 confddir = $(pkgpythondir)/confd
47 rapidir = $(pkgpythondir)/rapi
48 serverdir = $(pkgpythondir)/server
49 watcherdir = $(pkgpythondir)/watcher
50 impexpddir = $(pkgpythondir)/impexpd
51 utilsdir = $(pkgpythondir)/utils
52 toolsdir = $(pkglibdir)/tools
53 iallocatorsdir = $(pkglibdir)/iallocators
54 pytoolsdir = $(pkgpythondir)/tools
55 docdir = $(datadir)/doc/$(PACKAGE)
56 myexeclibdir = $(pkglibdir)
57
58 # Delete output file if an error occurred while building it
59 .DELETE_ON_ERROR:
60
61 HS_DIRS = \
62         src \
63         src/Ganeti \
64         src/Ganeti/Block \
65         src/Ganeti/Block/Drbd \
66         src/Ganeti/Confd \
67         src/Ganeti/DataCollectors \
68         src/Ganeti/HTools \
69         src/Ganeti/HTools/Backend \
70         src/Ganeti/HTools/Program \
71         src/Ganeti/Query \
72         test/hs \
73         test/hs/Test \
74         test/hs/Test/Ganeti \
75         test/hs/Test/Ganeti/Block \
76         test/hs/Test/Ganeti/Block/Drbd \
77         test/hs/Test/Ganeti/Confd \
78         test/hs/Test/Ganeti/HTools \
79         test/hs/Test/Ganeti/HTools/Backend \
80         test/hs/Test/Ganeti/Query
81
82 # Haskell directories without the roots (src, test/hs)
83 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
84
85 DIRS = \
86         $(HS_DIRS) \
87         autotools \
88         daemons \
89         devel \
90         doc \
91         doc/css \
92         doc/examples \
93         doc/examples/gnt-debug \
94         doc/examples/hooks \
95         test/data/htools \
96         test/data/htools/rapi \
97         test/hs/shelltests \
98         lib \
99         lib/build \
100         lib/client \
101         lib/confd \
102         lib/http \
103         lib/hypervisor \
104         lib/impexpd \
105         lib/masterd \
106         lib/rapi \
107         lib/server \
108         lib/tools \
109         lib/utils \
110         lib/watcher \
111         man \
112         qa \
113         test \
114         test/data \
115         test/data/bdev-rbd \
116         test/data/ovfdata \
117         test/data/ovfdata/other \
118         test/py \
119         tools
120
121 ALL_APIDOC_HS_DIRS = \
122         $(APIDOC_HS_DIR) \
123         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
124
125 BUILDTIME_DIR_AUTOCREATE = \
126         scripts \
127         $(APIDOC_DIR) \
128         $(ALL_APIDOC_HS_DIRS) \
129         $(APIDOC_PY_DIR) \
130         $(COVERAGE_DIR) \
131         $(COVERAGE_HS_DIR) \
132         $(COVERAGE_PY_DIR) \
133         .hpc
134
135 BUILDTIME_DIRS = \
136         $(BUILDTIME_DIR_AUTOCREATE) \
137         doc/html \
138         doc/man-html
139
140 DIRCHECK_EXCLUDE = \
141         $(BUILDTIME_DIRS) \
142         ganeti-[0-9]*.[0-9]*.[0-9]* \
143         doc/html/_* \
144         doc/man-html/_* \
145         autom4te.cache
146
147 # some helper vars
148 COVERAGE_DIR = doc/coverage
149 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
150 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
151 APIDOC_DIR = doc/api
152 APIDOC_PY_DIR = $(APIDOC_DIR)/py
153 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
154
155 MAINTAINERCLEANFILES = \
156         $(maninput) \
157         doc/install-quick.rst \
158         doc/news.rst \
159         doc/upgrade.rst \
160         vcs-version
161
162 maintainer-clean-local:
163         rm -rf $(BUILDTIME_DIRS)
164
165 CLEANFILES = \
166         $(addsuffix /*.py[co],$(DIRS)) \
167         $(addsuffix /*.hi,$(HS_DIRS)) \
168         $(addsuffix /*.o,$(HS_DIRS)) \
169         $(PYTHON_BOOTSTRAP) \
170         epydoc.conf \
171         $(REPLACE_VARS_SED) \
172         $(SHELL_ENV_INIT) \
173         daemons/daemon-util \
174         daemons/ganeti-cleaner \
175         $(mandocrst) \
176         doc/manpages-enabled.rst \
177         $(BUILT_EXAMPLES) \
178         doc/examples/bash_completion \
179         doc/examples/bash_completion-debug \
180         lib/_generated_rpc.py \
181         $(man_MANS) \
182         $(manhtml) \
183         tools/kvm-ifup \
184         tools/vcluster-setup \
185         stamp-directories \
186         stamp-srclinks \
187         $(nodist_pkgpython_PYTHON) \
188         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
189         $(HS_BUILT_TEST_HELPERS) \
190         src/ganeti-confd \
191         .hpc/*.mix src/*.tix test/hs/*.tix \
192         doc/hs-lint.html
193
194 GENERATED_FILES = \
195         $(built_base_sources) \
196         $(BUILT_PYTHON_SOURCES) \
197         $(PYTHON_BOOTSTRAP)
198
199 HS_GENERATED_FILES =
200 if WANT_HTOOLS
201 HS_GENERATED_FILES += $(HS_PROGS)
202 if ENABLE_CONFD
203 HS_GENERATED_FILES += src/hconfd src/ganeti-confd
204 endif
205 endif
206
207 built_base_sources = \
208         stamp-directories \
209         stamp-srclinks
210
211 built_python_base_sources = \
212         lib/_autoconf.py \
213         lib/_vcsversion.py
214
215 BUILT_PYTHON_SOURCES = \
216         $(built_python_base_sources) \
217         lib/_generated_rpc.py
218
219 # Generating the RPC wrappers depends on many things, so make sure
220 # it's built at the end of the built sources
221 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
222
223 # these are all built from the underlying %.in sources
224 BUILT_EXAMPLES = \
225         doc/examples/ganeti-kvm-poweroff.initd \
226         doc/examples/ganeti.cron \
227         doc/examples/ganeti.initd \
228         doc/examples/ganeti-master-role.ocf \
229         doc/examples/ganeti-node-role.ocf \
230         doc/examples/gnt-config-backup \
231         doc/examples/hooks/ipsec
232
233 nodist_pkgpython_PYTHON = \
234         $(BUILT_PYTHON_SOURCES)
235
236 noinst_PYTHON = \
237         lib/build/__init__.py \
238         lib/build/shell_example_lexer.py \
239         lib/build/sphinx_ext.py
240
241 pkgpython_PYTHON = \
242         lib/__init__.py \
243         lib/asyncnotifier.py \
244         lib/backend.py \
245         lib/bdev.py \
246         lib/bootstrap.py \
247         lib/cli.py \
248         lib/cmdlib.py \
249         lib/compat.py \
250         lib/config.py \
251         lib/constants.py \
252         lib/daemon.py \
253         lib/errors.py \
254         lib/ht.py \
255         lib/jqueue.py \
256         lib/jstore.py \
257         lib/locking.py \
258         lib/luxi.py \
259         lib/mcpu.py \
260         lib/netutils.py \
261         lib/objects.py \
262         lib/opcodes.py \
263         lib/outils.py \
264         lib/ovf.py \
265         lib/pathutils.py \
266         lib/qlang.py \
267         lib/query.py \
268         lib/rpc.py \
269         lib/rpc_defs.py \
270         lib/runtime.py \
271         lib/serializer.py \
272         lib/ssconf.py \
273         lib/ssh.py \
274         lib/storage.py \
275         lib/uidpool.py \
276         lib/vcluster.py \
277         lib/network.py \
278         lib/workerpool.py
279
280 client_PYTHON = \
281         lib/client/__init__.py \
282         lib/client/gnt_backup.py \
283         lib/client/gnt_cluster.py \
284         lib/client/gnt_debug.py \
285         lib/client/gnt_group.py \
286         lib/client/gnt_instance.py \
287         lib/client/gnt_job.py \
288         lib/client/gnt_node.py \
289         lib/client/gnt_network.py \
290         lib/client/gnt_os.py \
291         lib/client/gnt_storage.py
292
293 hypervisor_PYTHON = \
294         lib/hypervisor/__init__.py \
295         lib/hypervisor/hv_base.py \
296         lib/hypervisor/hv_chroot.py \
297         lib/hypervisor/hv_fake.py \
298         lib/hypervisor/hv_kvm.py \
299         lib/hypervisor/hv_lxc.py \
300         lib/hypervisor/hv_xen.py
301
302 rapi_PYTHON = \
303         lib/rapi/__init__.py \
304         lib/rapi/baserlib.py \
305         lib/rapi/client.py \
306         lib/rapi/client_utils.py \
307         lib/rapi/connector.py \
308         lib/rapi/rlib2.py \
309         lib/rapi/testutils.py
310
311 http_PYTHON = \
312         lib/http/__init__.py \
313         lib/http/auth.py \
314         lib/http/client.py \
315         lib/http/server.py
316
317 confd_PYTHON = \
318         lib/confd/__init__.py \
319         lib/confd/client.py
320
321 masterd_PYTHON = \
322         lib/masterd/__init__.py \
323         lib/masterd/iallocator.py \
324         lib/masterd/instance.py
325
326 impexpd_PYTHON = \
327         lib/impexpd/__init__.py
328
329 watcher_PYTHON = \
330         lib/watcher/__init__.py \
331         lib/watcher/nodemaint.py \
332         lib/watcher/state.py
333
334 server_PYTHON = \
335         lib/server/__init__.py \
336         lib/server/masterd.py \
337         lib/server/noded.py \
338         lib/server/rapi.py
339
340 pytools_PYTHON = \
341         lib/tools/__init__.py \
342         lib/tools/burnin.py \
343         lib/tools/ensure_dirs.py \
344         lib/tools/node_cleanup.py \
345         lib/tools/node_daemon_setup.py \
346         lib/tools/prepare_node_join.py
347
348 utils_PYTHON = \
349         lib/utils/__init__.py \
350         lib/utils/algo.py \
351         lib/utils/filelock.py \
352         lib/utils/hash.py \
353         lib/utils/io.py \
354         lib/utils/log.py \
355         lib/utils/lvm.py \
356         lib/utils/mlock.py \
357         lib/utils/nodesetup.py \
358         lib/utils/process.py \
359         lib/utils/retry.py \
360         lib/utils/text.py \
361         lib/utils/wrapper.py \
362         lib/utils/x509.py
363
364 docinput = \
365         doc/conf.py \
366         doc/css/style.css \
367         doc/admin.rst \
368         doc/cluster-merge.rst \
369         doc/design-2.0.rst \
370         doc/design-2.1.rst \
371         doc/design-2.2.rst \
372         doc/design-2.3.rst \
373         doc/design-2.4.rst \
374         doc/design-2.5.rst \
375         doc/design-2.6.rst \
376         doc/design-2.7.rst \
377         doc/design-autorepair.rst \
378         doc/design-bulk-create.rst \
379         doc/design-chained-jobs.rst \
380         doc/design-cpu-pinning.rst \
381         doc/design-draft.rst \
382         doc/design-htools-2.3.rst \
383         doc/design-http-server.rst \
384         doc/design-impexp2.rst \
385         doc/design-lu-generated-jobs.rst \
386         doc/design-linuxha.rst \
387         doc/design-multi-reloc.rst \
388         doc/design-network.rst \
389         doc/design-node-add.rst \
390         doc/design-oob.rst \
391         doc/design-ovf-support.rst \
392         doc/design-opportunistic-locking.rst \
393         doc/design-partitioned.rst \
394         doc/design-query-splitting.rst \
395         doc/design-query2.rst \
396         doc/design-resource-model.rst \
397         doc/design-restricted-commands.rst \
398         doc/design-shared-storage.rst \
399         doc/design-monitoring-agent.rst \
400         doc/design-virtual-clusters.rst \
401         doc/design-x509-ca.rst \
402         doc/devnotes.rst \
403         doc/glossary.rst \
404         doc/hooks.rst \
405         doc/iallocator.rst \
406         doc/index.rst \
407         doc/install-quick.rst \
408         doc/install.rst \
409         doc/locking.rst \
410         doc/manpages-disabled.rst \
411         doc/move-instance.rst \
412         doc/news.rst \
413         doc/ovfconverter.rst \
414         doc/rapi.rst \
415         doc/security.rst \
416         doc/upgrade.rst \
417         doc/virtual-cluster.rst \
418         doc/walkthrough.rst
419
420 # Generates file names such as "doc/man-gnt-instance.rst"
421 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
422
423 # Haskell programs to be installed in $PREFIX/bin
424 HS_BIN_PROGS=src/htools
425
426 # Haskell programs to be installed in the MYEXECLIB dir
427 HS_MYEXECLIB_PROGS=src/mon-collector
428
429 # Haskell programs to compiled but not installed automatically
430 # Usually they have their own specific installation rules
431 HS_COMPILE_PROGS= \
432         src/hconfd \
433         src/rpc-test
434
435 # All Haskell non-test programs to be compiled but not automatically installed
436 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
437
438 HS_BIN_ROLES = hbal hscan hspace hinfo hcheck hroller
439 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
440
441 HS_ALL_PROGS = \
442         $(HS_PROGS) \
443         test/hs/hpc-htools \
444         test/hs/hpc-mon-collector \
445         test/hs/htest \
446         $(HS_COMPILE_PROGS)
447
448 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
449 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
450
451 HFLAGS = \
452         -O -Wall -Werror -isrc \
453         -fwarn-monomorphism-restriction \
454         -fwarn-tabs \
455         $(GHC_BYVERSION_FLAGS)
456
457 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
458 HEXTRA =
459 # internal extra flags (used for test/hs/htest mainly)
460 HEXTRA_INT =
461 # exclude options for coverage reports
462 HPCEXCL = --exclude Main \
463         --exclude Ganeti.Constants \
464         --exclude Ganeti.HTools.QC \
465         --exclude Ganeti.THH \
466         --exclude Ganeti.Version \
467         --exclude Test.Ganeti.Attoparsec \
468         --exclude Test.Ganeti.TestCommon \
469         --exclude Test.Ganeti.TestHTools \
470         --exclude Test.Ganeti.TestHelper \
471         --exclude Test.Ganeti.TestImports \
472         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
473
474 HS_LIB_SRCS = \
475         src/Ganeti/Block/Drbd/Types.hs \
476         src/Ganeti/Block/Drbd/Parser.hs \
477         src/Ganeti/BasicTypes.hs \
478         src/Ganeti/Common.hs \
479         src/Ganeti/Compat.hs \
480         src/Ganeti/Confd/Client.hs \
481         src/Ganeti/Confd/Server.hs \
482         src/Ganeti/Confd/Types.hs \
483         src/Ganeti/Confd/Utils.hs \
484         src/Ganeti/Config.hs \
485         src/Ganeti/Daemon.hs \
486         src/Ganeti/DataCollectors/CLI.hs \
487         src/Ganeti/DataCollectors/Drbd.hs \
488         src/Ganeti/DataCollectors/Program.hs \
489         src/Ganeti/DataCollectors/Types.hs \
490         src/Ganeti/Errors.hs \
491         src/Ganeti/HTools/Backend/IAlloc.hs \
492         src/Ganeti/HTools/Backend/Luxi.hs \
493         src/Ganeti/HTools/Backend/Rapi.hs \
494         src/Ganeti/HTools/Backend/Simu.hs \
495         src/Ganeti/HTools/Backend/Text.hs \
496         src/Ganeti/HTools/CLI.hs \
497         src/Ganeti/HTools/Cluster.hs \
498         src/Ganeti/HTools/Container.hs \
499         src/Ganeti/HTools/ExtLoader.hs \
500         src/Ganeti/HTools/Graph.hs \
501         src/Ganeti/HTools/Group.hs \
502         src/Ganeti/HTools/Instance.hs \
503         src/Ganeti/HTools/Loader.hs \
504         src/Ganeti/HTools/Node.hs \
505         src/Ganeti/HTools/PeerMap.hs \
506         src/Ganeti/HTools/Program/Hail.hs \
507         src/Ganeti/HTools/Program/Hbal.hs \
508         src/Ganeti/HTools/Program/Hcheck.hs \
509         src/Ganeti/HTools/Program/Hinfo.hs \
510         src/Ganeti/HTools/Program/Hscan.hs \
511         src/Ganeti/HTools/Program/Hspace.hs \
512         src/Ganeti/HTools/Program/Hroller.hs \
513         src/Ganeti/HTools/Program/Main.hs \
514         src/Ganeti/HTools/Types.hs \
515         src/Ganeti/Hash.hs \
516         src/Ganeti/JQueue.hs \
517         src/Ganeti/JSON.hs \
518         src/Ganeti/Jobs.hs \
519         src/Ganeti/Logging.hs \
520         src/Ganeti/Luxi.hs \
521         src/Ganeti/Network.hs \
522         src/Ganeti/Objects.hs \
523         src/Ganeti/OpCodes.hs \
524         src/Ganeti/OpParams.hs \
525         src/Ganeti/Path.hs \
526         src/Ganeti/Query/Common.hs \
527         src/Ganeti/Query/Filter.hs \
528         src/Ganeti/Query/Group.hs \
529         src/Ganeti/Query/Job.hs \
530         src/Ganeti/Query/Language.hs \
531         src/Ganeti/Query/Node.hs \
532         src/Ganeti/Query/Query.hs \
533         src/Ganeti/Query/Server.hs \
534         src/Ganeti/Query/Types.hs \
535         src/Ganeti/Rpc.hs \
536         src/Ganeti/Runtime.hs \
537         src/Ganeti/Ssconf.hs \
538         src/Ganeti/THH.hs \
539         src/Ganeti/Types.hs \
540         src/Ganeti/Utils.hs
541
542 HS_TEST_SRCS = \
543         test/hs/Test/Ganeti/Attoparsec.hs \
544         test/hs/Test/Ganeti/BasicTypes.hs \
545         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
546         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
547         test/hs/Test/Ganeti/Common.hs \
548         test/hs/Test/Ganeti/Confd/Types.hs \
549         test/hs/Test/Ganeti/Confd/Utils.hs \
550         test/hs/Test/Ganeti/Daemon.hs \
551         test/hs/Test/Ganeti/Errors.hs \
552         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
553         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
554         test/hs/Test/Ganeti/HTools/CLI.hs \
555         test/hs/Test/Ganeti/HTools/Cluster.hs \
556         test/hs/Test/Ganeti/HTools/Container.hs \
557         test/hs/Test/Ganeti/HTools/Graph.hs \
558         test/hs/Test/Ganeti/HTools/Instance.hs \
559         test/hs/Test/Ganeti/HTools/Loader.hs \
560         test/hs/Test/Ganeti/HTools/Node.hs \
561         test/hs/Test/Ganeti/HTools/PeerMap.hs \
562         test/hs/Test/Ganeti/HTools/Types.hs \
563         test/hs/Test/Ganeti/JSON.hs \
564         test/hs/Test/Ganeti/Jobs.hs \
565         test/hs/Test/Ganeti/JQueue.hs \
566         test/hs/Test/Ganeti/Luxi.hs \
567         test/hs/Test/Ganeti/Network.hs \
568         test/hs/Test/Ganeti/Objects.hs \
569         test/hs/Test/Ganeti/OpCodes.hs \
570         test/hs/Test/Ganeti/Query/Filter.hs \
571         test/hs/Test/Ganeti/Query/Language.hs \
572         test/hs/Test/Ganeti/Query/Query.hs \
573         test/hs/Test/Ganeti/Rpc.hs \
574         test/hs/Test/Ganeti/Runtime.hs \
575         test/hs/Test/Ganeti/Ssconf.hs \
576         test/hs/Test/Ganeti/THH.hs \
577         test/hs/Test/Ganeti/TestCommon.hs \
578         test/hs/Test/Ganeti/TestHTools.hs \
579         test/hs/Test/Ganeti/TestHelper.hs \
580         test/hs/Test/Ganeti/Types.hs \
581         test/hs/Test/Ganeti/Utils.hs
582
583 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
584
585 HS_BUILT_SRCS = \
586         test/hs/Test/Ganeti/TestImports.hs \
587         src/Ganeti/Constants.hs \
588         src/Ganeti/Version.hs
589 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
590
591 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
592
593 $(RUN_IN_TEMPDIR): | stamp-directories
594
595 doc/html/index.html: ENABLE_MANPAGES =
596 doc/man-html/index.html: ENABLE_MANPAGES = 1
597 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
598
599 # Note: we use here an order-only prerequisite, as the contents of
600 # _autoconf.py are not actually influencing the html build output: it
601 # has to exist in order for the sphinx module to be loaded
602 # successfully, but we certainly don't want the docs to be rebuilt if
603 # it changes
604 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
605         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
606         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
607         doc/css/style.css \
608         | $(BUILT_PYTHON_SOURCES)
609         @test -n "$(SPHINX)" || \
610             { echo 'sphinx-build' not found during configure; exit 1; }
611 if !MANPAGES_IN_DOC
612         if test -n '$(ENABLE_MANPAGES)'; then \
613           echo 'Man pages in documentation were disabled at configure time' >&2; \
614           exit 1; \
615         fi
616 endif
617 ## Sphinx provides little control over what content should be included. Some
618 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
619 ## build two different versions of the documentation--once without man pages and
620 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
621 ## us with this, but requires running in a temporary directory. It moves the
622 ## correct files into place depending on environment variables.
623         dir=$(dir $@) && \
624         @mkdir_p@ $$dir && \
625         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
626         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
627             -d . \
628             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
629             -D release="$(PACKAGE_VERSION)" \
630             -D graphviz_dot="$(DOT)" \
631             -D enable_manpages="$(ENABLE_MANPAGES)" \
632             doc $(CURDIR)/$$dir && \
633         rm -f $$dir/.buildinfo $$dir/objects.inv
634         touch $@
635
636 doc/html: doc/html/index.html
637
638 doc/man-html: doc/man-html/index.html
639
640 doc/install-quick.rst: INSTALL
641 doc/news.rst: NEWS
642 doc/upgrade.rst: UPGRADE
643
644 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
645         set -e; \
646         { echo '.. This file is automatically updated at build time from $<.'; \
647           echo '.. Do not edit.'; \
648           echo; \
649           cat $<; \
650         } > $@
651
652 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
653         { echo '.. This file is automatically generated, do not edit!'; \
654           echo ''; \
655           echo 'Man pages'; \
656           echo '========='; \
657           echo; \
658           echo '.. toctree::'; \
659           echo '   :maxdepth: 1'; \
660           echo; \
661           for i in $(notdir $(mandocrst)); do \
662             echo "   $$i"; \
663           done | LC_ALL=C sort; \
664         } > $@
665
666 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
667 if MANPAGES_IN_DOC
668         { echo '.. This file is automatically updated at build time from $<.'; \
669           echo '.. Do not edit.'; \
670           echo; \
671           echo "$*"; \
672           echo '=========================================='; \
673           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
674         } > $@
675 else
676         echo 'Man pages in documentation were disabled at configure time' >&2; \
677         exit 1;
678 endif
679
680 # Things to build but not to install (add it to EXTRA_DIST if it should be
681 # distributed)
682 noinst_DATA = \
683         doc/html \
684         $(BUILT_EXAMPLES) \
685         doc/examples/bash_completion \
686         doc/examples/bash_completion-debug \
687         $(manhtml)
688
689 if MANPAGES_IN_DOC
690 noinst_DATA += doc/man-html
691 endif
692
693 gnt_scripts = \
694         scripts/gnt-backup \
695         scripts/gnt-cluster \
696         scripts/gnt-debug \
697         scripts/gnt-group \
698         scripts/gnt-instance \
699         scripts/gnt-job \
700         scripts/gnt-network \
701         scripts/gnt-node \
702         scripts/gnt-os \
703         scripts/gnt-storage
704
705 PYTHON_BOOTSTRAP_SBIN = \
706         daemons/ganeti-masterd \
707         daemons/ganeti-noded \
708         daemons/ganeti-rapi \
709         daemons/ganeti-watcher \
710         $(gnt_scripts)
711
712 PYTHON_BOOTSTRAP = \
713         $(PYTHON_BOOTSTRAP_SBIN) \
714         tools/burnin \
715         tools/ensure-dirs \
716         tools/node-cleanup \
717         tools/node-daemon-setup \
718         tools/prepare-node-join
719
720 qa_scripts = \
721         qa/__init__.py \
722         qa/ganeti-qa.py \
723         qa/qa_cluster.py \
724         qa/qa_config.py \
725         qa/qa_daemon.py \
726         qa/qa_env.py \
727         qa/qa_error.py \
728         qa/qa_group.py \
729         qa/qa_instance.py \
730         qa/qa_job.py \
731         qa/qa_node.py \
732         qa/qa_os.py \
733         qa/qa_rapi.py \
734         qa/qa_tags.py \
735         qa/qa_utils.py
736
737 bin_SCRIPTS =
738 if WANT_HTOOLS
739 bin_SCRIPTS += $(HS_BIN_PROGS)
740 install-exec-hook:
741         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
742 # FIXME: this is a hardcoded logic, instead of auto-resolving
743         $(LN_S) -f ../../../bin/htools \
744           $(DESTDIR)$(iallocatorsdir)/hail
745         for role in $(HS_BIN_ROLES); do \
746           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
747         done
748 endif
749
750 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
751         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
752           echo "Error: cannot run unittests without the development" \
753                " libraries (see devnotes.rst)" 1>&2; \
754           exit 1; \
755         fi
756         @rm -f $(notdir $@).tix
757         $(GHC) --make \
758           $(HFLAGS) \
759           $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
760           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
761           $(HEXTRA) $(HEXTRA_INT) $@
762         @touch "$@"
763
764 # for the test/hs/htest binary, we need to enable profiling/coverage
765 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
766
767 # we compile the hpc-htools binary with the program coverage
768 test/hs/hpc-htools: HEXTRA_INT=-fhpc
769
770 # we compile the hpc-mon-collector binary with the program coverage
771 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
772
773 # test dependency
774 test/hs/offline-tests.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
775
776 # rules for building profiling-enabled versions of the haskell
777 # programs: hs-prof does the full two-step build, whereas
778 # hs-prof-quick does only the final rebuild (hs-prof must have been
779 # run before)
780 .PHONY: hs-prof hs-prof-quick
781 hs-prof:
782         @if [ -z "$(TARGET)" ]; then \
783           echo "You need to define TARGET when running this rule" 1>&2; \
784           exit 1; \
785         fi
786         $(MAKE) $(AM_MAKEFLAGS) clean
787         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
788         rm -f $(HS_ALL_PROGS)
789         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
790
791 hs-prof-quick:
792         @if [ -z "$(TARGET)" ]; then \
793           echo "You need to define TARGET when running this rule" 1>&2; \
794           exit 1; \
795         fi
796         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
797
798 dist_sbin_SCRIPTS = \
799         tools/ganeti-listrunner
800
801 nodist_sbin_SCRIPTS = \
802         $(PYTHON_BOOTSTRAP_SBIN) \
803         daemons/ganeti-cleaner
804
805 if ENABLE_CONFD
806 src/ganeti-confd: src/hconfd
807         cp -f $< $@
808
809 nodist_sbin_SCRIPTS += src/ganeti-confd
810 endif
811
812 python_scripts = \
813         tools/cfgshell \
814         tools/cfgupgrade \
815         tools/cfgupgrade12 \
816         tools/cluster-merge \
817         tools/confd-client \
818         tools/fmtjson \
819         tools/lvmstrap \
820         tools/move-instance \
821         tools/ovfconverter \
822         tools/sanitize-config
823
824 dist_tools_SCRIPTS = \
825         $(python_scripts) \
826         tools/kvm-console-wrapper \
827         tools/master-ip-setup \
828         tools/xen-console-wrapper
829
830 nodist_tools_python_scripts = \
831         tools/node-cleanup
832
833 nodist_tools_SCRIPTS = \
834         $(nodist_tools_python_scripts) \
835         tools/vcluster-setup
836
837 pkglib_python_scripts = \
838         daemons/import-export \
839         tools/check-cert-expired
840
841 nodist_pkglib_python_scripts = \
842         tools/burnin \
843         tools/ensure-dirs \
844         tools/node-daemon-setup \
845         tools/prepare-node-join
846
847 myexeclib_SCRIPTS = \
848         daemons/daemon-util \
849         tools/kvm-ifup \
850         $(pkglib_python_scripts) \
851         $(HS_MYEXECLIB_PROGS)
852
853 nodist_myexeclib_SCRIPTS = \
854         $(nodist_pkglib_python_scripts)
855
856 EXTRA_DIST = \
857         NEWS \
858         UPGRADE \
859         epydoc.conf.in \
860         pylintrc \
861         autotools/build-bash-completion \
862         autotools/build-rpc \
863         autotools/check-header \
864         autotools/check-imports \
865         autotools/check-man-dashes \
866         autotools/check-man-references \
867         autotools/check-man-warnings \
868         autotools/check-news \
869         autotools/check-python-code \
870         autotools/check-tar \
871         autotools/check-version \
872         autotools/convert-constants \
873         autotools/docpp \
874         autotools/gen-py-coverage \
875         autotools/sphinx-wrapper \
876         autotools/testrunner \
877         autotools/wrong-hardcoded-paths \
878         $(RUN_IN_TEMPDIR) \
879         daemons/daemon-util.in \
880         daemons/ganeti-cleaner.in \
881         $(pkglib_python_scripts) \
882         devel/upload \
883         devel/webserver \
884         tools/kvm-ifup.in \
885         tools/vcluster-setup.in \
886         $(docinput) \
887         doc/html \
888         $(BUILT_EXAMPLES:%=%.in) \
889         doc/examples/ganeti.default \
890         doc/examples/ganeti.default-debug \
891         doc/examples/hooks/ethers \
892         doc/examples/gnt-debug/README \
893         doc/examples/gnt-debug/delay0.json \
894         doc/examples/gnt-debug/delay50.json \
895         test/py/lockperf.py \
896         test/py/testutils.py \
897         test/py/mocks.py \
898         $(dist_TESTS) \
899         $(TEST_FILES) \
900         man/footer.rst \
901         $(manrst) \
902         $(maninput) \
903         qa/qa-sample.json \
904         $(qa_scripts) \
905         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
906         $(HS_PROG_SRCS) \
907         src/lint-hints.hs \
908         test/hs/cli-tests-defs.sh \
909         test/hs/offline-test.sh \
910         .ghci
911
912 man_MANS = \
913         man/ganeti-cleaner.8 \
914         man/ganeti-confd.8 \
915         man/ganeti-listrunner.8 \
916         man/ganeti-masterd.8 \
917         man/ganeti-noded.8 \
918         man/ganeti-os-interface.7 \
919         man/ganeti-extstorage-interface.7 \
920         man/ganeti-rapi.8 \
921         man/ganeti-watcher.8 \
922         man/ganeti.7 \
923         man/gnt-backup.8 \
924         man/gnt-cluster.8 \
925         man/gnt-debug.8 \
926         man/gnt-group.8 \
927         man/gnt-network.8 \
928         man/gnt-instance.8 \
929         man/gnt-job.8 \
930         man/gnt-node.8 \
931         man/gnt-os.8 \
932         man/gnt-storage.8 \
933         man/hail.1 \
934         man/hbal.1 \
935         man/hcheck.1 \
936         man/hinfo.1 \
937         man/hscan.1 \
938         man/hspace.1 \
939         man/hroller.1 \
940         man/htools.1 \
941         man/mon-collector.7
942
943 # Remove extensions from all filenames in man_MANS
944 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
945
946 manrst = $(patsubst %,%.rst,$(mannoext))
947 manhtml = $(patsubst %.rst,%.html,$(manrst))
948 mangen = $(patsubst %.rst,%.gen,$(manrst))
949 maninput = \
950         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
951         $(patsubst %.html,%.html.in,$(manhtml)) \
952         $(mangen)
953
954 TEST_FILES = \
955         test/data/htools/clean-nonzero-score.data \
956         test/data/htools/common-suffix.data \
957         test/data/htools/empty-cluster.data \
958         test/data/htools/hail-alloc-drbd.json \
959         test/data/htools/hail-change-group.json \
960         test/data/htools/hail-invalid-reloc.json \
961         test/data/htools/hail-node-evac.json \
962         test/data/htools/hail-reloc-drbd.json \
963         test/data/htools/hbal-excl-tags.data \
964         test/data/htools/hbal-split-insts.data \
965         test/data/htools/invalid-node.data \
966         test/data/htools/missing-resources.data \
967         test/data/htools/n1-failure.data \
968         test/data/htools/rapi/groups.json \
969         test/data/htools/rapi/info.json \
970         test/data/htools/rapi/instances.json \
971         test/data/htools/rapi/nodes.json \
972         test/hs/shelltests/htools-balancing.test \
973         test/hs/shelltests/htools-basic.test \
974         test/hs/shelltests/htools-dynutil.test \
975         test/hs/shelltests/htools-excl.test \
976         test/hs/shelltests/htools-hail.test \
977         test/hs/shelltests/htools-hspace.test \
978         test/hs/shelltests/htools-invalid.test \
979         test/hs/shelltests/htools-multi-group.test \
980         test/hs/shelltests/htools-no-backend.test \
981         test/hs/shelltests/htools-rapi.test \
982         test/hs/shelltests/htools-single-group.test \
983         test/hs/shelltests/htools-text-backend.test \
984         test/hs/shelltests/htools-mon-collector.test \
985         test/data/bdev-drbd-8.0.txt \
986         test/data/bdev-drbd-8.3.txt \
987         test/data/bdev-drbd-disk.txt \
988         test/data/bdev-drbd-net-ip4.txt \
989         test/data/bdev-drbd-net-ip6.txt \
990         test/data/bdev-rbd/json_output_empty.txt \
991         test/data/bdev-rbd/json_output_extra_matches.txt \
992         test/data/bdev-rbd/json_output_no_matches.txt \
993         test/data/bdev-rbd/json_output_ok.txt \
994         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
995         test/data/bdev-rbd/plain_output_new_no_matches.txt \
996         test/data/bdev-rbd/plain_output_new_ok.txt \
997         test/data/bdev-rbd/plain_output_old_empty.txt \
998         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
999         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1000         test/data/bdev-rbd/plain_output_old_ok.txt \
1001         test/data/bdev-rbd/output_invalid.txt \
1002         test/data/cert1.pem \
1003         test/data/cert2.pem \
1004         test/data/instance-minor-pairing.txt \
1005         test/data/ip-addr-show-dummy0.txt \
1006         test/data/ip-addr-show-lo-ipv4.txt \
1007         test/data/ip-addr-show-lo-ipv6.txt \
1008         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1009         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1010         test/data/ip-addr-show-lo-oneline.txt \
1011         test/data/ip-addr-show-lo.txt \
1012         test/data/kvm_0.12.5_help.txt \
1013         test/data/kvm_0.15.90_help.txt \
1014         test/data/kvm_0.9.1_help.txt \
1015         test/data/kvm_0.9.1_help_boot_test.txt \
1016         test/data/kvm_1.0_help.txt \
1017         test/data/kvm_1.1.2_help.txt \
1018         test/data/ovfdata/compr_disk.vmdk.gz \
1019         test/data/ovfdata/config.ini \
1020         test/data/ovfdata/corrupted_resources.ovf \
1021         test/data/ovfdata/empty.ini \
1022         test/data/ovfdata/empty.ovf \
1023         test/data/ovfdata/ganeti.mf \
1024         test/data/ovfdata/ganeti.ovf \
1025         test/data/ovfdata/gzip_disk.ovf \
1026         test/data/ovfdata/new_disk.vmdk \
1027         test/data/ovfdata/no_disk.ini \
1028         test/data/ovfdata/no_disk_in_ref.ovf \
1029         test/data/ovfdata/no_os.ini \
1030         test/data/ovfdata/no_ovf.ova \
1031         test/data/ovfdata/other/rawdisk.raw \
1032         test/data/ovfdata/ova.ova \
1033         test/data/ovfdata/rawdisk.raw \
1034         test/data/ovfdata/second_disk.vmdk \
1035         test/data/ovfdata/unsafe_path.ini \
1036         test/data/ovfdata/virtualbox.ovf \
1037         test/data/ovfdata/wrong_config.ini \
1038         test/data/ovfdata/wrong_extension.ovd \
1039         test/data/ovfdata/wrong_manifest.mf \
1040         test/data/ovfdata/wrong_manifest.ovf \
1041         test/data/ovfdata/wrong_ova.ova \
1042         test/data/ovfdata/wrong_xml.ovf \
1043         test/data/proc_drbd8.txt \
1044         test/data/proc_drbd80-emptyline.txt \
1045         test/data/proc_drbd83.txt \
1046         test/data/proc_drbd83_sync.txt \
1047         test/data/proc_drbd83_sync_want.txt \
1048         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1049         test/data/sys_drbd_usermode_helper.txt \
1050         test/data/vgreduce-removemissing-2.02.02.txt \
1051         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1052         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1053         test/data/vgs-missing-pvs-2.02.02.txt \
1054         test/data/vgs-missing-pvs-2.02.66.txt \
1055         test/py/ganeti-cli.test \
1056         test/py/gnt-cli.test \
1057         test/py/import-export_unittest-helper
1058
1059 python_tests = \
1060         doc/examples/rapi_testutils.py \
1061         test/py/cfgupgrade_unittest.py \
1062         test/py/docs_unittest.py \
1063         test/py/ganeti.asyncnotifier_unittest.py \
1064         test/py/ganeti.backend_unittest-runasroot.py \
1065         test/py/ganeti.backend_unittest.py \
1066         test/py/ganeti.bdev_unittest.py \
1067         test/py/ganeti.cli_unittest.py \
1068         test/py/ganeti.client.gnt_cluster_unittest.py \
1069         test/py/ganeti.client.gnt_instance_unittest.py \
1070         test/py/ganeti.client.gnt_job_unittest.py \
1071         test/py/ganeti.cmdlib_unittest.py \
1072         test/py/ganeti.compat_unittest.py \
1073         test/py/ganeti.confd.client_unittest.py \
1074         test/py/ganeti.config_unittest.py \
1075         test/py/ganeti.constants_unittest.py \
1076         test/py/ganeti.daemon_unittest.py \
1077         test/py/ganeti.errors_unittest.py \
1078         test/py/ganeti.hooks_unittest.py \
1079         test/py/ganeti.ht_unittest.py \
1080         test/py/ganeti.http_unittest.py \
1081         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1082         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1083         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1084         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1085         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1086         test/py/ganeti.hypervisor_unittest.py \
1087         test/py/ganeti.impexpd_unittest.py \
1088         test/py/ganeti.jqueue_unittest.py \
1089         test/py/ganeti.jstore_unittest.py \
1090         test/py/ganeti.locking_unittest.py \
1091         test/py/ganeti.luxi_unittest.py \
1092         test/py/ganeti.masterd.iallocator_unittest.py \
1093         test/py/ganeti.masterd.instance_unittest.py \
1094         test/py/ganeti.mcpu_unittest.py \
1095         test/py/ganeti.netutils_unittest.py \
1096         test/py/ganeti.objects_unittest.py \
1097         test/py/ganeti.opcodes_unittest.py \
1098         test/py/ganeti.outils_unittest.py \
1099         test/py/ganeti.ovf_unittest.py \
1100         test/py/ganeti.qlang_unittest.py \
1101         test/py/ganeti.query_unittest.py \
1102         test/py/ganeti.rapi.baserlib_unittest.py \
1103         test/py/ganeti.rapi.client_unittest.py \
1104         test/py/ganeti.rapi.resources_unittest.py \
1105         test/py/ganeti.rapi.rlib2_unittest.py \
1106         test/py/ganeti.rapi.testutils_unittest.py \
1107         test/py/ganeti.rpc_unittest.py \
1108         test/py/ganeti.runtime_unittest.py \
1109         test/py/ganeti.serializer_unittest.py \
1110         test/py/ganeti.server.rapi_unittest.py \
1111         test/py/ganeti.ssconf_unittest.py \
1112         test/py/ganeti.ssh_unittest.py \
1113         test/py/ganeti.storage_unittest.py \
1114         test/py/ganeti.tools.burnin_unittest.py \
1115         test/py/ganeti.tools.ensure_dirs_unittest.py \
1116         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1117         test/py/ganeti.tools.prepare_node_join_unittest.py \
1118         test/py/ganeti.uidpool_unittest.py \
1119         test/py/ganeti.utils.algo_unittest.py \
1120         test/py/ganeti.utils.filelock_unittest.py \
1121         test/py/ganeti.utils.hash_unittest.py \
1122         test/py/ganeti.utils.io_unittest-runasroot.py \
1123         test/py/ganeti.utils.io_unittest.py \
1124         test/py/ganeti.utils.log_unittest.py \
1125         test/py/ganeti.utils.lvm_unittest.py \
1126         test/py/ganeti.utils.mlock_unittest.py \
1127         test/py/ganeti.utils.nodesetup_unittest.py \
1128         test/py/ganeti.utils.process_unittest.py \
1129         test/py/ganeti.utils.retry_unittest.py \
1130         test/py/ganeti.utils.text_unittest.py \
1131         test/py/ganeti.utils.wrapper_unittest.py \
1132         test/py/ganeti.utils.x509_unittest.py \
1133         test/py/ganeti.utils_unittest.py \
1134         test/py/ganeti.vcluster_unittest.py \
1135         test/py/ganeti.workerpool_unittest.py \
1136         test/py/pycurl_reset_unittest.py \
1137         test/py/qa.qa_config_unittest.py \
1138         test/py/tempfile_fork_unittest.py
1139
1140 haskell_tests = test/hs/htest
1141
1142 dist_TESTS = \
1143         test/py/check-cert-expired_unittest.bash \
1144         test/py/daemon-util_unittest.bash \
1145         test/py/ganeti-cleaner_unittest.bash \
1146         test/py/import-export_unittest.bash \
1147         test/py/cli-test.bash \
1148         test/py/bash_completion.bash \
1149         $(python_tests)
1150
1151 nodist_TESTS =
1152 check_SCRIPTS =
1153
1154 if WANT_HSTESTS
1155 nodist_TESTS += $(haskell_tests)
1156 dist_TESTS += test/hs/offline-test.sh
1157 check_SCRIPTS += \
1158         test/hs/hpc-htools \
1159         test/hs/hpc-mon-collector \
1160         $(HS_BUILT_TEST_HELPERS)
1161 endif
1162
1163 TESTS = $(dist_TESTS) $(nodist_TESTS)
1164
1165 # Environment for all tests
1166 PLAIN_TESTS_ENVIRONMENT = \
1167         PYTHONPATH=. \
1168         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1169         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1170         $(RUN_IN_TEMPDIR)
1171
1172 # Environment for tests run by automake
1173 TESTS_ENVIRONMENT = \
1174         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1175
1176 all_python_code = \
1177         $(dist_sbin_SCRIPTS) \
1178         $(python_scripts) \
1179         $(pkglib_python_scripts) \
1180         $(nodist_pkglib_python_scripts) \
1181         $(nodist_tools_python_scripts) \
1182         $(python_tests) \
1183         $(pkgpython_PYTHON) \
1184         $(client_PYTHON) \
1185         $(hypervisor_PYTHON) \
1186         $(rapi_PYTHON) \
1187         $(server_PYTHON) \
1188         $(pytools_PYTHON) \
1189         $(http_PYTHON) \
1190         $(confd_PYTHON) \
1191         $(masterd_PYTHON) \
1192         $(impexpd_PYTHON) \
1193         $(utils_PYTHON) \
1194         $(watcher_PYTHON) \
1195         $(noinst_PYTHON) \
1196         $(qa_scripts)
1197
1198 srclink_files = \
1199         man/footer.rst \
1200         test/py/check-cert-expired_unittest.bash \
1201         test/py/daemon-util_unittest.bash \
1202         test/py/ganeti-cleaner_unittest.bash \
1203         test/py/import-export_unittest.bash \
1204         test/py/cli-test.bash \
1205         test/py/bash_completion.bash \
1206         test/hs/offline-test.sh \
1207         test/hs/cli-tests-defs.sh \
1208         $(all_python_code) \
1209         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1210         $(docinput)
1211
1212 check_python_code = \
1213         $(BUILD_BASH_COMPLETION) \
1214         $(CHECK_IMPORTS) \
1215         $(CHECK_HEADER) \
1216         $(DOCPP) \
1217         $(all_python_code)
1218
1219 lint_python_code = \
1220         ganeti \
1221         ganeti/http/server.py \
1222         $(dist_sbin_SCRIPTS) \
1223         $(python_scripts) \
1224         $(pkglib_python_scripts) \
1225         $(BUILD_BASH_COMPLETION) \
1226         $(CHECK_IMPORTS) \
1227         $(CHECK_HEADER) \
1228         $(DOCPP) \
1229         $(PYTHON_BOOTSTRAP)
1230
1231 standalone_python_modules = \
1232         lib/rapi/client.py \
1233         tools/ganeti-listrunner
1234
1235 pep8_python_code = \
1236         ganeti \
1237         ganeti/http/server.py \
1238         $(dist_sbin_SCRIPTS) \
1239         $(python_scripts) \
1240         $(pkglib_python_scripts) \
1241         $(BUILD_BASH_COMPLETION) \
1242         $(CHECK_HEADER) \
1243         $(DOCPP) \
1244         $(PYTHON_BOOTSTRAP) \
1245         qa
1246
1247 test/py/daemon-util_unittest.bash: daemons/daemon-util
1248
1249 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1250
1251 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1252
1253 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1254         sed -f $(REPLACE_VARS_SED) < $< > $@
1255         chmod +x $@
1256
1257 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1258         sed -f $(REPLACE_VARS_SED) < $< > $@
1259         chmod +x $@
1260
1261 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1262         sed -f $(REPLACE_VARS_SED) < $< > $@
1263         chmod +x $@
1264
1265 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1266         sed -f $(REPLACE_VARS_SED) < $< > $@
1267
1268 doc/examples/bash_completion: BC_ARGS = --compact
1269 doc/examples/bash_completion-debug: BC_ARGS =
1270
1271 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1272         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1273         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1274         daemons/ganeti-cleaner \
1275         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1276         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1277           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1278
1279 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1280         lib/build/shell_example_lexer.py \
1281         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1282         @echo "Checking $< for hardcoded paths..."
1283         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1284           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1285           exit 1; \
1286         fi
1287         set -e ; \
1288         trap 'echo auto-removing $@; rm $@' EXIT; \
1289         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1290         $(CHECK_MAN_REFERENCES) $@; \
1291         trap - EXIT
1292
1293 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1294         @test -n "$(PANDOC)" || \
1295           { echo 'pandoc' not found during configure; exit 1; }
1296         set -o pipefail -e; \
1297         trap 'echo auto-removing $@; rm $@' EXIT; \
1298         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1299           sed -e 's/\\@/@/g' > $@; \
1300         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1301         $(CHECK_MAN_DASHES) $@; \
1302         trap - EXIT
1303
1304 man/%.html.in: man/%.gen man/footer.rst
1305         @test -n "$(PANDOC)" || \
1306           { echo 'pandoc' not found during configure; exit 1; }
1307         set -o pipefail ; \
1308         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1309           sed -e 's/\\@/@/g' > $@
1310
1311 man/%: man/%.in  $(REPLACE_VARS_SED)
1312         sed -f $(REPLACE_VARS_SED) < $< > $@
1313
1314 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1315         sed -f $(REPLACE_VARS_SED) < $< > $@
1316
1317 vcs-version:
1318         if test -d .git; then \
1319           git describe > $@; \
1320         elif test ! -f $@ ; then \
1321           echo "Cannot auto-generate $@ file"; exit 1; \
1322         fi
1323
1324 .PHONY: clean-vcs-version
1325 clean-vcs-version:
1326         rm -f vcs-version
1327
1328 .PHONY: regen-vcs-version
1329 regen-vcs-version:
1330         @set -e; \
1331         cd $(srcdir); \
1332         if test -d .git; then \
1333           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1334           git describe > $$T; \
1335           if ! cmp --quiet $$T vcs-version; then \
1336             mv $$T vcs-version; \
1337           fi; \
1338         fi
1339
1340 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1341         vcs-version $(built_base_sources)
1342         set -e; \
1343         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1344         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1345
1346 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1347         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1348         lib/jstore.py $(RUN_IN_TEMPDIR) \
1349         $(CONVERT_CONSTANTS) $(built_base_sources) \
1350         | lib/_vcsversion.py
1351         set -e; \
1352         { cat $< ; \
1353           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1354         } > $@
1355
1356 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1357         $(built_base_sources)
1358         set -e; \
1359         { cat $< ; \
1360           echo ; \
1361           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1362             echo "import $$name ()" ; \
1363           done ; \
1364         } > $@
1365
1366 lib/_autoconf.py: Makefile | stamp-directories
1367         set -e; \
1368         { echo '# This file is automatically generated, do not edit!'; \
1369           echo '#'; \
1370           echo ''; \
1371           echo '"""Build-time configuration for Ganeti.'; \
1372           echo '';\
1373           echo 'This file is autogenerated by the build process.'; \
1374           echo 'For any changes you need to re-run ./configure (and'; \
1375           echo 'not edit by hand).'; \
1376           echo ''; \
1377           echo '"""'; \
1378           echo ''; \
1379           echo '# pylint: disable=C0301,C0324'; \
1380           echo '# because this is autogenerated, we do not want'; \
1381           echo '# style warnings' ; \
1382           echo ''; \
1383           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1384           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1385           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1386           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1387           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1388           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1389           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1390           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1391           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1392           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1393           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1394           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1395           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1396           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1397           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1398           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1399           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1400           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1401           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1402           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1403           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1404           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1405           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1406           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1407           echo "KVM_PATH = '$(KVM_PATH)'"; \
1408           echo "IP_PATH = '$(IP_PATH)'"; \
1409           echo "SOCAT_PATH = '$(SOCAT)'"; \
1410           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1411           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1412           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1413           echo "TOOLSDIR = '$(toolsdir)'"; \
1414           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1415           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1416           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1417           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1418           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1419           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1420           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1421           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1422           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1423           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1424           echo "RAPI_USER = '$(RAPI_USER)'"; \
1425           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1426           echo "CONFD_USER = '$(CONFD_USER)'"; \
1427           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1428           echo "NODED_USER = '$(NODED_USER)'"; \
1429           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1430           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1431           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1432           echo "HTOOLS = True"; \
1433           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1434           echo "XEN_CMD = '$(XEN_CMD)'"; \
1435           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1436           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1437           echo "ENABLE_MONITORING = $(ENABLE_MONITORING)"; \
1438 ## Write dictionary with man page name as the key and the section number as the
1439 ## value
1440           echo "MAN_PAGES = {"; \
1441           for i in $(notdir $(man_MANS)); do \
1442             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1443           done; \
1444           echo "}"; \
1445         } > $@
1446
1447 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1448         set -e; \
1449         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1450         { echo '# This file is automatically generated, do not edit!'; \
1451           echo '#'; \
1452           echo ''; \
1453           echo '"""Build-time VCS version number for Ganeti.'; \
1454           echo '';\
1455           echo 'This file is autogenerated by the build process.'; \
1456           echo 'For any changes you need to re-run ./configure (and'; \
1457           echo 'not edit by hand).'; \
1458           echo ''; \
1459           echo '"""'; \
1460           echo ''; \
1461           echo '# pylint: disable=C0301,C0324'; \
1462           echo '# because this is autogenerated, we do not want'; \
1463           echo '# style warnings' ; \
1464           echo ''; \
1465           echo "VCS_VERSION = '$$VCSVER'"; \
1466         } > $@
1467
1468 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1469         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1470
1471 $(SHELL_ENV_INIT): Makefile stamp-directories
1472         set -e; \
1473         { echo '# Allow overriding for tests'; \
1474           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1475           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1476           echo; \
1477           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1478           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1479           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1480           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1481           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1482         } > $@
1483
1484 ## Writes sed script to replace placeholders with build-time values. The
1485 ## additional quotes after the first @ sign are necessary to stop configure
1486 ## from replacing those values as well.
1487 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1488         set -e; \
1489         { echo 's#@''PREFIX@#$(prefix)#g'; \
1490           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1491           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1492           echo 's#@''BINDIR@#$(bindir)#g'; \
1493           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1494           echo 's#@''LIBDIR@#$(libdir)#g'; \
1495           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1496           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1497           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1498           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1499           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1500           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1501           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1502           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1503           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1504           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1505           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1506           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1507           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1508           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1509           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1510           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1511           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1512           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1513           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1514           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1515           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1516           echo; \
1517           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1518           echo '  r $(SHELL_ENV_INIT)'; \
1519           echo '  d'; \
1520           echo '}'; \
1521         } > $@
1522
1523 # Using deferred evaluation
1524 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1525 daemons/ganeti-watcher: MODULE = ganeti.watcher
1526 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1527 tools/burnin: MODULE = ganeti.tools.burnin
1528 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1529 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1530 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1531 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1532 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1533
1534 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1535         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1536         set -e; \
1537         { echo '#!/usr/bin/python'; \
1538           echo '# This file is automatically generated, do not edit!'; \
1539           echo "# Edit $(MODULE) instead."; \
1540           echo; \
1541           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1542           echo; \
1543           echo '# pylint: disable=C0103'; \
1544           echo '# C0103: Invalid name'; \
1545           echo; \
1546           echo 'import sys'; \
1547           echo 'import $(MODULE) as main'; \
1548           echo; \
1549           echo '# Temporarily alias commands until bash completion'; \
1550           echo '# generator is changed'; \
1551           echo 'if hasattr(main, "commands"):'; \
1552           echo '  commands = main.commands # pylint: disable=E1101'; \
1553           echo 'if hasattr(main, "aliases"):'; \
1554           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1555           echo; \
1556           echo 'if __name__ == "__main__":'; \
1557           echo '  sys.exit(main.Main())'; \
1558         } > $@
1559         chmod u+x $@
1560
1561 $(HS_BUILT_TEST_HELPERS): Makefile
1562         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1563         set -e; \
1564         { echo '#!/bin/sh'; \
1565           echo '# This file is automatically generated, do not edit!'; \
1566           echo "# Edit Makefile.am instead."; \
1567           echo; \
1568           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1569         } > $@
1570         chmod u+x $@
1571
1572 stamp-directories: Makefile
1573         $(MAKE) $(AM_MAKEFLAGS) ganeti
1574         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1575         touch $@
1576
1577 # We need to create symlinks because "make distcheck" will not install Python
1578 # files when building.
1579 stamp-srclinks: Makefile | stamp-directories
1580         set -e; \
1581         for i in $(srclink_files); do \
1582           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1583             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1584           fi; \
1585         done
1586         touch $@
1587
1588 .PHONY: ganeti
1589 ganeti:
1590         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1591
1592 .PHONY: check-dirs
1593 check-dirs: $(GENERATED_FILES)
1594         @set -e; \
1595         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1596           error=; \
1597           while read dir; do \
1598             case "$$dir" in \
1599               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1600               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1601             esac; \
1602           done; \
1603           for dir in $(DIRS); do \
1604             if ! test -d "$$dir"; then \
1605               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1606               error=1; \
1607             fi \
1608           done; \
1609           test -z "$$error"; \
1610         }
1611
1612 .PHONY: check-local
1613 check-local: check-dirs $(GENERATED_FILES)
1614         $(CHECK_PYTHON_CODE) $(check_python_code)
1615         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1616         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1617         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1618         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1619         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1620         error= ; \
1621         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1622           echo "Incorrect version in README, expected $$expver" >&2; \
1623           error=1; \
1624         fi; \
1625         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1626             doc/security.rst; do \
1627           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1628             "Documents Ganeti version $$expver"; then \
1629             echo "Incorrect version in $$file, expected $$expver" >&2; \
1630             error=1; \
1631           fi; \
1632         done; \
1633         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1634           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1635           error=1; \
1636         fi; \
1637         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1638           ".. Last updated for Ganeti $$expver"; then \
1639           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1640           error=1; \
1641         fi; \
1642         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1643           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1644             echo "Longest line in $$file is longer than 80 characters" >&2; \
1645             error=1; \
1646           fi; \
1647         done; \
1648         test -z "$$error"
1649
1650 .PHONY: hs-tests
1651 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1652         @rm -f htest.tix
1653         ./test/hs/htest
1654
1655 .PHONY: hs-shell
1656 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1657         @rm -f hpc-htools.tix hpc-mon-collector.tix
1658         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1659
1660 .PHONY: hs-check
1661 hs-check: hs-tests hs-shell
1662
1663 # E111: indentation is not a multiple of four
1664 # E121: continuation line indentation is not a multiple of four
1665 #       (since our indent level is not 4)
1666 # E125: continuation line does not distinguish itself from next logical line
1667 #       (since our indent level is not 4)
1668 # E127: continuation line over-indented for visual indent
1669 #       (since our indent level is not 4)
1670 # note: do NOT add E128 here; it's a valid style error in most cases!
1671 # I've seen real errors, but also some cases were we indent wrongly
1672 # due to line length; try to rework the cases where it is triggered,
1673 # instead of silencing it
1674 # E261: at least two spaces before inline comment
1675 # E501: line too long (80 characters)
1676 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1677
1678 # For excluding pep8 expects filenames only, not whole paths
1679 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1680
1681 LINT_TARGETS = pylint pylint-qa
1682 if HAS_PEP8
1683 LINT_TARGETS += pep8
1684 endif
1685 if HAS_HLINT
1686 LINT_TARGETS += hlint
1687 endif
1688
1689 .PHONY: lint
1690 lint: $(LINT_TARGETS)
1691
1692 .PHONY: pylint
1693 pylint: $(GENERATED_FILES)
1694         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1695         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1696
1697 .PHONY: pylint-qa
1698 pylint-qa: $(GENERATED_FILES)
1699         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1700         cd $(top_srcdir)/qa && \
1701           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1702           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1703
1704 .PHONY: pep8
1705 pep8: $(GENERATED_FILES)
1706         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1707         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1708           --repeat $(pep8_python_code)
1709
1710 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1711 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1712 .PHONY: hlint
1713 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1714         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1715         @rm -f doc/hs-lint.html
1716         if tty -s; then C="-c"; else C=""; fi; \
1717         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1718           --ignore "Use first" \
1719           --ignore "Use &&&" \
1720           --ignore "Use void" \
1721           --ignore "Reduce duplication" \
1722           --hint src/lint-hints \
1723           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1724         @if [ ! -f doc/hs-lint.html ]; then \
1725           echo "All good" > doc/hs-lint.html; \
1726         fi
1727
1728 # a dist hook rule for updating the vcs-version file; this is
1729 # hardcoded due to where it needs to build the file...
1730 dist-hook:
1731         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1732         rm -f $(top_distdir)/vcs-version
1733         cp -p $(srcdir)/vcs-version $(top_distdir)
1734
1735 # a distcheck hook rule for catching revision control directories
1736 distcheck-hook:
1737         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1738           echo "Found revision control files in final archive." 1>&2; \
1739           exit 1; \
1740         fi
1741         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1742           echo "Found Python byte code in final archive." 1>&2; \
1743           exit 1; \
1744         fi
1745         if find $(top_distdir) -name '*~' | grep .; then \
1746           echo "Found backup files in final archive." 1>&2; \
1747           exit 1; \
1748         fi
1749 # Empty files or directories should not be distributed. They can cause
1750 # unnecessary warnings for packagers. Directories used by automake during
1751 # distcheck must be excluded.
1752         if find $(top_distdir) -empty -and -not \( \
1753             -path $(top_distdir)/_build -or \
1754             -path $(top_distdir)/_inst \) | grep .; then \
1755           echo "Found empty files or directories in final archive." 1>&2; \
1756           exit 1; \
1757         fi
1758         if test -n "$(BUILD_RELEASE)" && \
1759            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1760            echo "Found unreleased version in NEWS." >&2; \
1761            exit 1; \
1762         fi
1763         if test -e $(top_distdir)/doc/man-html; then \
1764           echo "Found documentation including man pages in final archive" >&2; \
1765           exit 1; \
1766         fi
1767
1768 # When building a release, stricter checks should be used
1769 distcheck-release dist-release: export BUILD_RELEASE = 1
1770 distcheck-release: distcheck
1771
1772 distrebuildcheck: dist
1773         set -e; \
1774         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1775         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1776         cd $$builddir; \
1777         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1778         cd $(distdir); \
1779         ./configure; \
1780         $(MAKE) maintainer-clean; \
1781         cp $(abs_srcdir)/vcs-version .; \
1782         ./configure; \
1783         $(MAKE) $(AM_MAKEFLAGS)
1784
1785 dist-release: dist
1786         set -e; \
1787         for i in $(DIST_ARCHIVES); do \
1788           echo -n "Checking $$i ... "; \
1789           autotools/check-tar < $$i; \
1790           echo OK; \
1791         done
1792
1793 install-exec-local:
1794         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1795           "$(DESTDIR)${localstatedir}/log/ganeti" \
1796           "$(DESTDIR)${localstatedir}/run/ganeti"
1797
1798 .PHONY: apidoc
1799 if WANT_HSAPIDOC
1800 apidoc: py-apidoc hs-apidoc
1801 else
1802 apidoc: py-apidoc
1803 endif
1804
1805 .PHONY: py-apidoc
1806 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1807         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1808         $(RUN_IN_TEMPDIR) epydoc -v \
1809           --conf $(CURDIR)/epydoc.conf \
1810           --output $(CURDIR)/$(APIDOC_PY_DIR)
1811
1812 .PHONY: hs-apidoc
1813 hs-apidoc: $(APIDOC_HS_DIR)/index.html
1814
1815 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
1816         @test -n "$(HSCOLOUR)" || \
1817             { echo 'HsColour' not found during configure; exit 1; }
1818         @test -n "$(HADDOCK)" || \
1819             { echo 'haddock' not found during configure; exit 1; }
1820         rm -rf $(APIDOC_HS_DIR)/*
1821         for i in $(ALL_APIDOC_HS_DIRS); do \
1822           @mkdir_p@ $$i; \
1823           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
1824         done
1825         set -e ; \
1826         export LC_ALL=en_US.UTF-8; \
1827         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
1828         if [ "$(HS_NOCURL)" ]; \
1829         then OPTGHC="$$OPTGHC --optghc=$(HS_NOCURL)"; \
1830         fi; \
1831         if [ "$(HS_PARALLEL3)" ]; \
1832         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
1833         fi; \
1834         if [ "$(HS_REGEX_PCRE)" ]; \
1835         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
1836         fi; \
1837         for file in $(HS_LIBTESTBUILT_SRCS); do \
1838           f_nosrc=$${file##src/}; \
1839           f_notst=$${f_nosrc##test/hs/}; \
1840           f_html=$${f_notst%%.hs}.html; \
1841           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
1842         done ; \
1843         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1844           -t ganeti -p src/haddock-prologue \
1845           --source-module="%{MODULE/.//}.html" \
1846           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1847           $$OPTGHC \
1848           $(HS_LIBTESTBUILT_SRCS)
1849
1850 .PHONY: TAGS
1851 TAGS: $(GENERATED_FILES)
1852         rm -f TAGS
1853         $(GHC) -e ":etags" -v0 \
1854           $(filter-out -O -Werror,$(HFLAGS)) \
1855           $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
1856           $(HS_LIBTEST_SRCS)
1857         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1858           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1859           -path './qa/*.py' | \
1860           etags -l python -a -
1861
1862 .PHONY: coverage
1863 if WANT_HTOOLS
1864 coverage: py-coverage hs-coverage
1865 else
1866 coverage: py-coverage
1867 endif
1868
1869 .PHONY: py-coverage
1870 py-coverage: $(GENERATED_FILES) $(python_tests)
1871         @test -n "$(PYCOVERAGE)" || \
1872             { echo 'python-coverage' not found during configure; exit 1; }
1873         set -e; \
1874         COVERAGE=$(PYCOVERAGE) \
1875         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1876         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1877         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1878         $(PLAIN_TESTS_ENVIRONMENT) \
1879         $(abs_top_srcdir)/autotools/gen-py-coverage \
1880         $(python_tests)
1881
1882 .PHONY: hs-coverage
1883 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
1884         rm -f *.tix
1885         $(MAKE) $(AM_MAKEFLAGS) hs-check
1886         @mkdir_p@ $(COVERAGE_HS_DIR)
1887         hpc sum --union $(HPCEXCL) \
1888           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
1889         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
1890         hpc report coverage-hs.tix
1891         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1892
1893 # Special "kind-of-QA" target for htools, needs special setup (all
1894 # tools compiled with -fhpc)
1895 .PHONY: live-test
1896 live-test: all
1897         set -e ; \
1898         cd src; \
1899         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1900         rm -f *.tix *.mix; \
1901         ./live-test.sh; \
1902         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
1903           --output=live-test.tix ; \
1904         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1905         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1906           --srcdir=.. $(HPCEXCL) ; \
1907         hpc report --srcdir=.. live-test $(HPCEXCL)
1908
1909 commit-check: distcheck lint apidoc
1910
1911 .PHONY: gitignore-check
1912 gitignore-check:
1913         @if [ -n "`git status --short`" ]; then \
1914           echo "Git status is not clean!" 1>&2 ; \
1915           git status --short; \
1916           exit 1; \
1917         fi
1918
1919 # target to rebuild all man pages (both groff and html output)
1920 .PHONY: man
1921 man: $(man_MANS) $(manhtml)
1922
1923 # Target that builds all binaries (including those that are not
1924 # rebuilt except when running the tests)
1925 .PHONY: really-all
1926 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
1927
1928 # we don't need the ancient implicit rules:
1929 %: %,v
1930 %: RCS/%,v
1931 %: RCS/%
1932 %: s.%
1933 %: SCCS/s.%
1934
1935 -include ./Makefile.local
1936
1937 # vim: set noet :